unit spl_arc;

interface

uses
  Windows,
  spl_com;

type
  TPluginInterfaceForArchiverAbstract = class
    function ListArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; dir: TSalamanderDirectoryAbstract; var pluginData: TPluginDataInterfaceAbstract): BOOL; virtual; stdcall; abstract;
    function UnpackArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; pluginData: TPluginDataInterfaceAbstract; targetDir: PAnsiChar; archiveRoot: PAnsiChar; next: TSalEnumSelectionFunc; nextParam: Pointer): BOOL; virtual; stdcall; abstract;
    function UnpackOneFile(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; pluginData: TPluginDataInterfaceAbstract; nameInArchive: PAnsiChar; fileData: PFileData; targetDir: PAnsiChar; newFileName: PAnsiChar; renamingNotSupported: PBOOL): BOOL; virtual; stdcall; abstract;
    function PackToArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; archiveRoot: PAnsiChar; move: BOOL; sourcePath: PAnsiChar; next: TSalEnumSelection2Func; nextParam: Pointer): BOOL; virtual; stdcall; abstract;
    function DeleteFromArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; pluginData: TPluginDataInterfaceAbstract; archiveRoot: PAnsiChar; next: TSalEnumSelectionFunc; nextParam: Pointer): BOOL; virtual; stdcall; abstract;
    function UnpackWholeArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; mask: PAnsiChar; targetDir: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function CanCloseArchive(salamander: TSalamanderForOperationsAbstract; fileName: PAnsiChar; force: BOOL; panel: Integer): BOOL; virtual; stdcall; abstract;
    function GetCacheInfo(tempPath: PAnsiChar; ownDelete: PBOOL; cacheCopies: PBOOL): BOOL; virtual; stdcall; abstract;
    procedure DeleteTmpCopy(fileName: PAnsiChar; firstFile: BOOL); virtual; stdcall; abstract;
    function PrematureDeleteTmpCopy(parent: HWND; copiesCount: Integer): BOOL; virtual; stdcall; abstract;
  end;

implementation

end.

