unit spl_gui;

interface

uses
  Windows,
  Messages,
  CommCtrl,
  winliblt;

const
  WM_USER_ENTERMENULOOP = WM_APP + 200;
  WM_USER_LEAVEMENULOOP = WM_APP + 201;
  WM_USER_LEAVEMENULOOP2 = WM_APP + 202;
  WM_USER_INITMENUPOPUP = WM_APP + 204;
  WM_USER_UNINITMENUPOPUP = WM_APP + 205;
  WM_USER_CONTEXTMENU = WM_APP + 206;

  WM_USER_TBDROPDOWN = WM_APP + 220;
  WM_USER_TBENUMBUTTON = WM_APP + 221;
  WM_USER_TBRESET = WM_APP + 222;
  WM_USER_TBBEGINADJUST = WM_APP + 223;
  WM_USER_TBENDADJUST = WM_APP + 224;
  WM_USER_TBGETTOOLTIP = WM_APP + 225;
  WM_USER_TBCHANGED = WM_APP + 226;
  WM_USER_TBENUMBUTTON2 = WM_APP + 227;

  TOOLTIP_TEXT_MAX = 5000;

  WM_USER_TTGETTEXT = WM_APP + 240;
  WM_USER_BUTTON = WM_APP + 244;
  WM_USER_BUTTONDROPDOWN = WM_APP + 245;
  WM_USER_KEYDOWN = WM_APP + 246;

  STF_CACHED_PAINT = $0000000001;
  STF_BOLD = $0000000002;
  STF_UNDERLINE = $0000000004;
  STF_DOTUNDERLINE = $0000000008;
  STF_HYPERLINK_COLOR = $0000000010;
  STF_END_ELLIPSIS = $0000000020;
  STF_PATH_ELLIPSIS = $0000000040;
  STF_HANDLEPREFIX = $0000000080;

  MNTT_IT = 1;
  MNTT_PB = 2;
  MNTT_PE = 3;
  MNTT_SP = 4;

  MNTS_B = $01;
  MNTS_I = $02;
  MNTS_A = $04;

  MENU_MASK_TYPE = $00000001;
  MENU_MASK_STATE = $00000002;
  MENU_MASK_ID = $00000004;
  MENU_MASK_SUBMENU = $00000008;
  MENU_MASK_CHECKMARKS = $00000010;
  MENU_MASK_BITMAP = $00000020;
  MENU_MASK_STRING = $00000080;
  MENU_MASK_IMAGEINDEX = $00000100;
  MENU_MASK_ICON = $00000200;
  MENU_MASK_OVERLAY = $00000400;
  MENU_MASK_CUSTOMDATA = $00000800;
  MENU_MASK_ENABLER = $00001000;
  MENU_MASK_SKILLLEVEL = $00002000;
  MENU_MASK_FLAGS = $00004000;

  MENU_TYPE_STRING = $00000001;
  MENU_TYPE_BITMAP = $00000002;
  MENU_TYPE_SEPARATOR = $00000004;
  MENU_TYPE_OWNERDRAW = $00000100;
  MENU_TYPE_RADIOCHECK = $00000200;

  MENU_FLAG_NOHOTKEY = $00000001;

  MENU_STATE_GRAYED = $00000001;
  MENU_STATE_CHECKED = $00000002;
  MENU_STATE_DEFAULT = $00000004;

  MENU_LEVEL_BEGINNER = $00000001;
  MENU_LEVEL_INTERMEDIATE = $00000002;
  MENU_LEVEL_ADVANCED = $00000004;

  MENU_POPUP_THREECOLUMNS = $00000001;
  MENU_POPUP_UPDATESTATES = $00000002;

  MENU_TRACK_SELECT = $00000001;
  MENU_TRACK_CENTERALIGN = $00000002;
  MENU_TRACK_RIGHTALIGN = $00000004;
  MENU_TRACK_VCENTERALIGN = $00000008;
  MENU_TRACK_BOTTOMALIGN = $00000010;
  MENU_TRACK_VERTICAL = $00000100;
  MENU_TRACK_NONOTIFY = $00001000;
  MENU_TRACK_RETURNCMD = $00002000;
  //MENU_TRACK_LEFTBUTTON = $00000000;
  MENU_TRACK_RIGHTBUTTON = $00010000;

  TLB_STYLE_IMAGE = $00000001;
  TLB_STYLE_TEXT = $00000002;
  TLB_STYLE_ADJUSTABLE = $00000004;
  TLB_STYLE_VERTICAL = $00000008;

  TLBI_MASK_ID = $00000001;
  TLBI_MASK_CUSTOMDATA = $00000002;
  TLBI_MASK_IMAGEINDEX = $00000004;
  TLBI_MASK_ICON = $00000008;
  TLBI_MASK_STATE = $00000010;
  TLBI_MASK_TEXT = $00000020;
  TLBI_MASK_TEXTLEN = $00000040;
  TLBI_MASK_STYLE = $00000080;
  TLBI_MASK_WIDTH = $00000100;
  TLBI_MASK_ENABLER = $00000200;
  TLBI_MASK_OVERLAY = $00000800;

  TLBI_STYLE_CHECK = $00000001;
  TLBI_STYLE_RADIO = $00000002;
  TLBI_STYLE_DROPDOWN = $00000004;
  TLBI_STYLE_NOPREFIX = $00000008;
  TLBI_STYLE_SEPARATOR = $00000010;
  TLBI_STYLE_SHOWTEXT = $00000020;
  TLBI_STYLE_WHOLEDROPDOWN = $00000040;
  TLBI_STYLE_SEPARATEDROPDOWN = $00000080;
  TLBI_STYLE_FIXEDWIDTH = $00000100;

  TLBI_STATE_CHECKED = $00000001;
  TLBI_STATE_GRAYED = $00000002;
  TLBI_STATE_PRESSED = $00000004;
  TLBI_STATE_DROPDOWNPRESSED = $00000008;
  
  TLBHDRMASK_MODIFY = $01;
  TLBHDRMASK_NEW = $02;
  TLBHDRMASK_DELETE = $04;
  TLBHDRMASK_SORT = $08;
  TLBHDRMASK_UP = $10;
  TLBHDRMASK_DOWN = $20;

  TLBHDR_MODIFY = 1;
  TLBHDR_NEW = 2;
  TLBHDR_DELETE = 3;
  TLBHDR_SORT = 4;
  TLBHDR_UP = 5;
  TLBHDR_DOWN = 6;

  BTF_CHECKBOX = $00000001;
  BTF_DROPDOWN = $00000002;
  BTF_LBUTTONDOWN = $00000004;
  BTF_RIGHTARROW = $00000008;
  BTF_MORE = $00000010;

type
  TGUIProgressBarAbstract = class
    procedure SetProgress(progress: DWORD; text: PAnsiChar); virtual; stdcall; abstract;
    procedure SetSelfMoveTime(time: DWORD); virtual; stdcall; abstract;
    procedure SetSelfMoveSpeed(moveTime: DWORD); virtual; stdcall; abstract;
    procedure Stop; virtual; stdcall; abstract;
  end;

  TGUIStaticTextAbstract = class
    function SetText(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetText: PAnsiChar; virtual; stdcall; abstract;
    procedure SetPathSeparator(separator: AnsiChar); virtual; stdcall; abstract;
    function SetToolTipText(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure SetToolTip(hNotifyWindow: HWND; id: DWORD); virtual; stdcall; abstract;
  end;

  TGUIHyperLinkAbstract = class
    function SetText(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function GetText: PAnsiChar; virtual; stdcall; abstract;
    procedure SetActionOpen(_file: PAnsiChar); virtual; stdcall; abstract;
    procedure SetActionPostCommand(command: Word); virtual; stdcall; abstract;
    function SetActionShowHint(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    function SetToolTipText(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure SetToolTip(hNotifyWindow: HWND; id: DWORD); virtual; stdcall; abstract;
  end;

  TGUIButtonAbstract = class
    function SetToolTipText(text: PAnsiChar): BOOL; virtual; stdcall; abstract;
    procedure SetToolTip(hNotifyWindow: HWND; id: DWORD); virtual; stdcall; abstract;
  end;

  TGUIColorArrowButtonAbstract = class
    procedure SetColor(textColor: TColorRef; bkgndColor: TColorRef); virtual; stdcall; abstract;
    procedure SetTextColor(textColor: TColorRef); virtual; stdcall; abstract;
    procedure SetBkgndColor(bkgndColor: TColorRef); virtual; stdcall; abstract;
    function GetTextColor: TColorRef; virtual; stdcall; abstract;
    function GetBkgndColor: TColorRef; virtual; stdcall; abstract;
  end;

  TGUIMenuPopupAbstract = class;

  MENU_TEMPLATE_ITEM = packed record
    RowType: Integer;
    TextResID: Integer;
    SkillLevel: Byte;
    ID: DWORD;
    ImageIndex: Shortint;
    State: DWORD;
    Enabler: PDWORD;
  end;
  PMENU_TEMPLATE_ITEM = ^MENU_TEMPLATE_ITEM;

  MENU_ITEM_INFO = packed record
    Mask: DWORD;
    Type_: DWORD;
    State: DWORD;
    ID: DWORD;
    SubMenu: TGUIMenuPopupAbstract;
    HBmpChecked: HBITMAP;
    HBmpUnchecked: HBITMAP;
    HBmpItem: HBITMAP;
    String_: PAnsiChar;
    StringLen: DWORD;
    ImageIndex: Integer;
    HIcon: HICON;
    HOverlay: HICON;
    CustomData: DWORD;
    SkillLevel: DWORD;
    Enabler: PDWORD;
    Flags: DWORD;
  end;
  PMENU_ITEM_INFO = ^MENU_ITEM_INFO;

  TGUIMenuPopupAbstract = class
    function LoadFromTemplate(hInstance: HINST; menuTemplate: PMENU_TEMPLATE_ITEM; enablersOffset: PDWORD; hImageList: HIMAGELIST; hHotImageList: HIMAGELIST): BOOL; virtual; stdcall; abstract;
    procedure SetSelectedItemIndex(index: Integer); virtual; stdcall; abstract;
    function GetSelectedItemIndex: Integer; virtual; stdcall; abstract;
    procedure SetTemplateMenu(hWindowsMenu: HMENU); virtual; stdcall; abstract;
    function GetTemplateMenu: HMENU; virtual; stdcall; abstract;
    function GetSubMenu(position: DWORD; byPosition: BOOL): TGUIMenuPopupAbstract; virtual; stdcall; abstract;
    function InsertItem(position: DWORD; byPosition: BOOL; mii: PMENU_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function SetItemInfo(position: DWORD; byPosition: BOOL; mii: PMENU_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function GetItemInfo(position: DWORD; byPosition: BOOL; mii: PMENU_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function SetStyle(style: DWORD): BOOL; virtual; stdcall; abstract;
    function CheckItem(position: DWORD; byPosition: BOOL; checked: BOOL): BOOL; virtual; stdcall; abstract;
    function CheckRadioItem(positionFirst: DWORD; positionLast: DWORD; positionCheck: DWORD; byPosition: BOOL): BOOL; virtual; stdcall; abstract;
    function SetDefaultItem(position: DWORD; byPosition: BOOL): BOOL; virtual; stdcall; abstract;
    function EnableItem(position: DWORD; byPosition: BOOL; enabled: BOOL): BOOL; virtual; stdcall; abstract;
    function GetItemCount: Integer; virtual; stdcall; abstract;
    procedure RemoveAllItems; virtual; stdcall; abstract;
    function RemoveItemsRange(firstIndex: Integer; lastIndex: Integer): BOOL; virtual; stdcall; abstract;
    function BeginModifyMode: BOOL; virtual; stdcall; abstract;
    function EndModifyMode: BOOL; virtual; stdcall; abstract;
    procedure SetSkillLevel(skillLevel: DWORD); virtual; stdcall; abstract;
    function FindItemPosition(id: DWORD): Integer; virtual; stdcall; abstract;
    function FillMenuHandle(hMenu: HMENU): BOOL; virtual; stdcall; abstract;
    function GetStatesFromHWindowsMenu(hMenu: HMENU): BOOL; virtual; stdcall; abstract;
    procedure SetImageList(hImageList: HIMAGELIST; subMenu: BOOL); virtual; stdcall; abstract;
    procedure SetHotImageList(hHotImageList: HIMAGELIST; subMenu: BOOL); virtual; stdcall; abstract;
    function Track(trackFlags: DWORD; x: Integer; y: Integer; hwnd: HWND; exclude: PRect): DWORD; virtual; stdcall; abstract;
    function GetItemRect(index: Integer; rect: PRect): BOOL; virtual; stdcall; abstract;
    procedure UpdateItemsState; virtual; stdcall; abstract;
    procedure SetMinWidth(minWidth: Integer); virtual; stdcall; abstract;
    procedure SetPopupID(id: DWORD); virtual; stdcall; abstract;
    function GetPopupID: DWORD; virtual; stdcall; abstract;
    procedure AssignHotKeys; virtual; stdcall; abstract;
  end;

  TGUIMenuBarAbstract = class
    function CreateWnd(hParent: HWND): BOOL; virtual; stdcall; abstract;
    function GetHWND: HWND; virtual; stdcall; abstract;
    function GetNeededWidth: Integer; virtual; stdcall; abstract;
    function GetNeededHeight: Integer; virtual; stdcall; abstract;
    procedure SetFont; virtual; stdcall; abstract;
    function GetItemRect(index: Integer; var r: TRect): BOOL; virtual; stdcall; abstract;
    procedure EnterMenu; virtual; stdcall; abstract;
    function IsInMenuLoop: BOOL; virtual; stdcall; abstract;
    procedure SetHelpMode(helpMode: BOOL); virtual; stdcall; abstract;
    function IsMenuBarMessage(lpMsg: PMsg): BOOL; virtual; stdcall; abstract;
  end;

  TLBI_ITEM_INFO = packed record
    Mask: DWORD;
    Style: DWORD;
    State: DWORD;
    ID: DWORD;
    Text: PAnsiChar;
    TextLen: Integer;
    Width: Integer;
    ImageIndex: Integer;
    HIcon: HICON;
    CustomData: DWORD;
    Enabler: PDWORD;
    Index: DWORD;
    Name: PAnsiChar;
    NameLen: Integer;
  end;
  PLBI_ITEM_INFO = ^TLBI_ITEM_INFO;

  TLBI_ITEM_INFO2 = packed record
    Mask: DWORD;
    Style: DWORD;
    State: DWORD;
    ID: DWORD;
    Text: PAnsiChar;
    TextLen: Integer;
    Width: Integer;
    ImageIndex: Integer;
    HIcon: HICON;
    HOverlay: HICON;
    CustomData: DWORD;
    Enabler: PDWORD;
    Index: DWORD;
    Name: PAnsiChar;
    NameLen: Integer;
  end;
  PLBI_ITEM_INFO2 = ^TLBI_ITEM_INFO2;

  TOOLBAR_PADDING = packed record
    ToolBarVertical: Word;
    ButtonIconText: Word;
    IconLeft: Word;
    IconRight: Word;
    TextLeft: Word;
    TextRight: Word;
  end;
  PTOOLBAR_PADDING = ^TOOLBAR_PADDING;

  TOOLBAR_TOOLTIP = packed record
    HToolBar: HWND;
    ID: DWORD;
    Index: DWORD;
    CustomData: DWORD;
    Buffer: PAnsiChar;

  end;
  PTOOLBAR_TOOLTIP = ^TOOLBAR_TOOLTIP;

  TGUIToolBarAbstract = class
    function CreateWnd(hParent: HWND): BOOL; virtual; stdcall; abstract;
    function GetHWND: HWND; virtual; stdcall; abstract;
    function GetNeededWidth: Integer; virtual; stdcall; abstract;
    function GetNeededHeight: Integer; virtual; stdcall; abstract;
    procedure SetFont; virtual; stdcall; abstract;
    function GetItemRect(index: Integer; var r: TRect): BOOL; virtual; stdcall; abstract;
    function InsertItem(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function SetItemInfo(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function GetItemInfo(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO): BOOL; virtual; stdcall; abstract;
    function CheckItem(position: DWORD; byPosition: BOOL; checked: BOOL): BOOL; virtual; stdcall; abstract;
    function EnableItem(position: DWORD; byPosition: BOOL; enabled: BOOL): BOOL; virtual; stdcall; abstract;
    function ReplaceImage(position: DWORD; byPosition: BOOL; hIcon: HICON; normal: BOOL; hot: BOOL): BOOL; virtual; stdcall; abstract;
    function FindItemPosition(id: DWORD): Integer; virtual; stdcall; abstract;
    procedure SetImageList(hImageList: HIMAGELIST); virtual; stdcall; abstract;
    function GetImageList: HIMAGELIST; virtual; stdcall; abstract;
    procedure SetHotImageList(hImageList: HIMAGELIST); virtual; stdcall; abstract;
    function GetHotImageList: HIMAGELIST; virtual; stdcall; abstract;
    procedure SetStyle(style: DWORD); virtual; stdcall; abstract;
    function GetStyle: DWORD; virtual; stdcall; abstract;
    function RemoveItem(position: DWORD; byPosition: BOOL): BOOL; virtual; stdcall; abstract;
    procedure RemoveAllItems; virtual; stdcall; abstract;
    function GetItemCount: Integer; virtual; stdcall; abstract;
    procedure Customize; virtual; stdcall; abstract;
    procedure SetPadding(padding: PTOOLBAR_PADDING); virtual; stdcall; abstract;
    procedure GetPadding(padding: PTOOLBAR_PADDING); virtual; stdcall; abstract;
    procedure UpdateItemsState; virtual; stdcall; abstract;
    function HitTest(xPos: Integer; yPos: Integer): Integer; virtual; stdcall; abstract;
    function InsertMarkHitTest(xPos: Integer; yPos: Integer; var index: Integer; var after: BOOL): BOOL; virtual; stdcall; abstract;
    procedure SetInsertMark(index: Integer; after: BOOL); virtual; stdcall; abstract;
    function SetHotItem(index: Integer): Integer; virtual; stdcall; abstract;
    procedure OnColorsChanged; virtual; stdcall; abstract;
    function InsertItem2(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall; abstract;
    function SetItemInfo2(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall; abstract;
    function GetItemInfo2(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall; abstract;
    function InsertItem2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall;
    function SetItemInfo2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall;
    function GetItemInfo2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL; virtual; stdcall;
  end;

  TGUIIconListAbstract = class
    function Create(imageWidth: Integer; imageHeight: Integer; imageCount: Integer): BOOL; virtual; stdcall; abstract;
    function CreateFromImageList(hIL: HIMAGELIST; requiredImageSize: Integer): BOOL; virtual; stdcall; abstract;
    function CreateFromPNG(hInstance: HINST; lpBitmapName: LPCTSTR; imageWidth: Integer): BOOL; virtual; stdcall; abstract;
    function ReplaceIcon(index: Integer; hIcon: HICON): BOOL; virtual; stdcall; abstract;
    function GetIcon(index: Integer): HICON; virtual; stdcall; abstract;
    function CreateFromRawPNG(rawPNG: Pointer; rawPNGSize: DWORD; imageWidth: Integer): BOOL; virtual; stdcall; abstract;
    function CreateAsCopy(iconList: TGUIIconListAbstract; grayscale: BOOL): BOOL; virtual; stdcall; abstract;
    function GetImageList: HIMAGELIST; virtual; stdcall; abstract;
    function CreateFromRawPNG_P(rawPNG: Pointer; rawPNGSize: DWORD; imageWidth: Integer): BOOL; virtual; stdcall;
    function CreateAsCopy_P(iconList: TGUIIconListAbstract; grayscale: BOOL): BOOL; virtual; stdcall;
    function GetImageList_P: HIMAGELIST; virtual; stdcall;
  end;

  TGUIToolbarHeaderAbstract = class
    procedure EnableToolbar(enableMask: DWORD); virtual; stdcall; abstract;
    procedure CheckToolbar(checkMask: DWORD); virtual; stdcall; abstract;
    procedure SetNotifyWindow(hWnd: HWND); virtual; stdcall; abstract;
  end;

  TSalamanderGUIAbstract = class
    function AttachProgressBar(hParent: HWND; ctrlID: Integer): TGUIProgressBarAbstract; virtual; stdcall; abstract;
    function AttachStaticText(hParent: HWND; ctrlID: Integer; flags: DWORD): TGUIStaticTextAbstract; virtual; stdcall; abstract;
    function AttachHyperLink(hParent: HWND; ctrlID: Integer; flags: DWORD): TGUIHyperLinkAbstract; virtual; stdcall; abstract;
    function AttachButton(hParent: HWND; ctrlID: Integer; flags: DWORD): TGUIButtonAbstract; virtual; stdcall; abstract;
    function AttachColorArrowButton(hParent: HWND; ctrlID: Integer; showArrow: BOOL): TGUIColorArrowButtonAbstract; virtual; stdcall; abstract;
    function ChangeToArrowButton(hParent: HWND; ctrlID: Integer): BOOL; virtual; stdcall; abstract;
    function CreateMenuPopup: TGUIMenuPopupAbstract; virtual; stdcall; abstract;
    function DestroyMenuPopup(popup: TGUIMenuPopupAbstract): BOOL; virtual; stdcall; abstract;
    function CreateMenuBar(menu: TGUIMenuPopupAbstract; hNotifyWindow: HWND): TGUIMenuBarAbstract; virtual; stdcall; abstract;
    function DestroyMenuBar(menuBar: TGUIMenuBarAbstract): BOOL; virtual; stdcall; abstract;
    function CreateGrayscaleAndMaskBitmaps(hSource: HBITMAP; transparent: TColorRef; var hGrayscale: HBITMAP; var hMask: HBITMAP): BOOL; virtual; stdcall; abstract;
    function CreateToolBar(hNotifyWindow: HWND): TGUIToolBarAbstract; virtual; stdcall; abstract;
    function DestroyToolBar(toolBar: TGUIToolBarAbstract): BOOL; virtual; stdcall; abstract;
    procedure SetCurrentToolTip(hNotifyWindow: HWND; id: DWORD); virtual; stdcall; abstract;
    procedure SuppressToolTipOnCurrentMousePos; virtual; stdcall; abstract;
    function DisableWindowVisualStyles(hWindow: HWND): BOOL; virtual; stdcall; abstract;
    function CreateIconList: TGUIIconListAbstract; virtual; stdcall; abstract;
    function DestroyIconList(iconList: TGUIIconListAbstract): BOOL; virtual; stdcall; abstract;
    procedure PrepareToolTipText(buf: PAnsiChar; stripHotKey: BOOL); virtual; stdcall; abstract;
    procedure SetSubjectTruncatedText(subjectWnd: HWND; subjectFormatString: PAnsiChar; fileName: PAnsiChar; isDir: BOOL; duplicateAmpersands: BOOL); virtual; stdcall; abstract;
    function AttachToolbarHeader(hParent: HWND; ctrlID: Integer; hAlignWindow: HWND; buttonMask: DWORD): TGUIToolbarHeaderAbstract; virtual; stdcall; abstract;
    function CreateIconList_P: TGUIIconListAbstract; virtual; stdcall;
    function DestroyIconList_P(iconList: TGUIIconListAbstract): BOOL; virtual; stdcall;
    procedure PrepareToolTipText_P(buf: PAnsiChar; stripHotKey: BOOL); virtual; stdcall;
    procedure SetSubjectTruncatedText_P(subjectWnd: HWND; subjectFormatString: PAnsiChar; fileName: PAnsiChar; isDir: BOOL; duplicateAmpersands: BOOL); virtual; stdcall;
    function AttachToolbarHeader_P(hParent: HWND; ctrlID: Integer; hAlignWindow: HWND; buttonMask: DWORD): TGUIToolbarHeaderAbstract; virtual; stdcall;
  end;

procedure CopyTLBI_ITEM_INFO(tii2: PLBI_ITEM_INFO2; tii: PLBI_ITEM_INFO); overload;
procedure CopyTLBI_ITEM_INFO(tii: PLBI_ITEM_INFO; tii2: PLBI_ITEM_INFO2); overload;

implementation

function TGUIToolBarAbstract.InsertItem2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL;
begin
  Result := InsertItem2(position, byPosition, tii);
end;

function TGUIToolBarAbstract.SetItemInfo2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL;
begin
  Result := SetItemInfo2(position, byPosition, tii);
end;

function TGUIToolBarAbstract.GetItemInfo2_P(position: DWORD; byPosition: BOOL; tii: PLBI_ITEM_INFO2): BOOL;
begin
  Result := GetItemInfo2(position, byPosition, tii);
end;

function TGUIIconListAbstract.CreateFromRawPNG_P(rawPNG: Pointer; rawPNGSize: DWORD; imageWidth: Integer): BOOL;
begin
  Result := CreateFromRawPNG(rawPNG, rawPNGSize, imageWidth);
end;

function TGUIIconListAbstract.CreateAsCopy_P(iconList: TGUIIconListAbstract; grayscale: BOOL): BOOL;
begin
  Result := CreateAsCopy(iconList, grayscale);
end;

function TGUIIconListAbstract.GetImageList_P: HIMAGELIST;
begin
  Result := GetImageList;
end;

function TSalamanderGUIAbstract.CreateIconList_P: TGUIIconListAbstract;
begin
  Result := CreateIconList;
end;

function TSalamanderGUIAbstract.DestroyIconList_P(iconList: TGUIIconListAbstract): BOOL;
begin
  Result := DestroyIconList(iconList);
end;

procedure TSalamanderGUIAbstract.PrepareToolTipText_P(buf: PAnsiChar; stripHotKey: BOOL);
begin
  PrepareToolTipText_P(buf, stripHotKey);
end;

procedure TSalamanderGUIAbstract.SetSubjectTruncatedText_P(subjectWnd: HWND;subjectFormatString: PAnsiChar; fileName: PAnsiChar; isDir: BOOL; duplicateAmpersands: BOOL);
begin
  SetSubjectTruncatedText(subjectWnd, subjectFormatString, fileName, isDir, duplicateAmpersands);
end;

function TSalamanderGUIAbstract.AttachToolbarHeader_P(hParent: HWND; ctrlID: Integer; hAlignWindow: HWND; buttonMask: DWORD): TGUIToolbarHeaderAbstract;
begin
  Result := AttachToolbarHeader(hParent, ctrlID, hAlignWindow, buttonMask);
end;

procedure CopyTLBI_ITEM_INFO(tii2: PLBI_ITEM_INFO2; tii: PLBI_ITEM_INFO); overload;
begin
  tii2.Mask := tii.Mask;
  tii2.Style := tii.Style;
  tii2.State := tii.State;
  tii2.ID := tii.ID;
  tii2.Text := tii.Text;
  tii2.TextLen := tii.TextLen;
  tii2.Width := tii.Width;
  tii2.ImageIndex := tii.ImageIndex;
  tii2.HIcon := tii.HIcon;
  tii2.HOverlay := 0;
  tii2.CustomData := tii.CustomData;
  tii2.Enabler := tii.Enabler;
  tii2.Index := tii.Index;
  tii2.Name := tii.Name;
  tii2.NameLen := tii.NameLen;
end;

procedure CopyTLBI_ITEM_INFO(tii: PLBI_ITEM_INFO; tii2: PLBI_ITEM_INFO2); overload;
begin
  tii.Mask := tii2.Mask;
  tii.Style := tii2.Style;
  tii.State := tii2.State;
  tii.ID := tii2.ID;
  tii.Text := tii2.Text;
  tii.TextLen := tii2.TextLen;
  tii.Width := tii2.Width;
  tii.ImageIndex := tii2.ImageIndex;
  tii.HIcon := tii2.HIcon;
  if ((tii2.Mask and MENU_MASK_OVERLAY) > 0) and (tii2.HOverlay <> 0) then
    ;
  tii.CustomData := tii2.CustomData;
  tii.Enabler := tii2.Enabler;
  tii.Index := tii2.Index;
  tii.Name := tii2.Name;
  tii.NameLen := tii2.NameLen;
end;

end.
